/* MainWindow.c generated by valac 0.43.6, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
* Copyright (c) 2018 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;
typedef enum  {
	MAIN_WINDOW_RANGE_LOW,
	MAIN_WINDOW_RANGE_LODPI_LOW,
	MAIN_WINDOW_RANGE_LODPI_IDEAL,
	MAIN_WINDOW_RANGE_LODPI_HIGH,
	MAIN_WINDOW_RANGE_HIDPI_LOW,
	MAIN_WINDOW_RANGE_HIDPI_IDEAL,
	MAIN_WINDOW_RANGE_HIDPI_HIGH,
	MAIN_WINDOW_RANGE_HIGH,
	MAIN_WINDOW_RANGE_UNCLEAR,
	MAIN_WINDOW_RANGE_INVALID
} MainWindowRange;

#define MAIN_WINDOW_TYPE_RANGE (main_window_range_get_type ())
typedef enum  {
	UTILS_DISPLAY_TYPE_INTERNAL,
	UTILS_DISPLAY_TYPE_EXTERNAL
} UtilsDisplayType;

#define UTILS_TYPE_DISPLAY_TYPE (utils_display_type_get_type ())
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	gint aspect_width;
	gint aspect_height;
	gdouble inches;
	gint width;
	gint height;
	gboolean is_default_display_type;
	gboolean is_default_width;
	gboolean is_default_height;
	gchar* direction;
	GtkImage* diagram;
	GtkEntry* diag_entry;
	GtkEntry* width_entry;
	GtkEntry* height_entry;
	GtkLabel* dpi_result_label;
	GtkLabel* logical_resolution_label;
	GtkLabel* aspect_result_label;
	GraniteWidgetsModeButton* type_modebutton;
	GtkLabel* range_title_label;
	GtkLabel* range_description_label;
	GtkImage* range_icon;
	MainWindowRange range;
	UtilsDisplayType display_type;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;

GType main_window_get_type (void) G_GNUC_CONST;
static GType main_window_range_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType utils_display_type_get_type (void) G_GNUC_CONST;
static gchar* main_window_range_title (MainWindowRange self);
static gchar* main_window_range_description (MainWindowRange self);
static gchar* main_window_range_icon (MainWindowRange self);
#define MAIN_WINDOW_DEFAULT_ASPECT_WIDTH 16
#define MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT 9
#define MAIN_WINDOW_INTERNAL_IDEAL_DPI 140
#define MAIN_WINDOW_INTERNAL_IDEAL_RANGE 16
#define MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE 14
#define MAIN_WINDOW_EXTERNAL_IDEAL_DPI 120
#define MAIN_WINDOW_EXTERNAL_IDEAL_RANGE 30
#define MAIN_WINDOW_EXTERNAL_UNCLEAR_RANGE 20
#define MAIN_WINDOW_INCHES_INFER_EXTERNAL ((gdouble) 18)
#define MAIN_WINDOW_DPI_INFER_HIDPI 192
MainWindow* main_window_new (GtkApplication* application);
MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static gint main_window_recalculate_dpi (MainWindow* self,
                                  gdouble inches,
                                  gint width,
                                  gint height);
gint utils_dpi (gdouble inches,
                gint width,
                gint height);
static void main_window_recalculate_logical_resolution (MainWindow* self,
                                                 gint width,
                                                 gint height,
                                                 gint dpi);
static void main_window_recalculate_aspect (MainWindow* self,
                                     gint width,
                                     gint height);
gint utils_greatest_common_divisor (gint a,
                                    gint b);
static void main_window_assess_dpi (MainWindow* self,
                             gdouble calculated_dpi,
                             UtilsDisplayType display_type);
static UtilsDisplayType main_window_infer_display_type (MainWindow* self,
                                                 gdouble inches);
static void main_window_set_display_icon (MainWindow* self);
gchar* utils_display_type_icon_suffix (UtilsDisplayType self);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _main_window___lambda4_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda4__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
static gboolean _main_window___lambda5_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
static gboolean _main_window___lambda6_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda6__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
gchar* utils_display_type_to_string (UtilsDisplayType self);
static void _main_window___lambda7_ (MainWindow* self);
static void __main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda8_ (MainWindow* self);
static void __main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda9_ (MainWindow* self);
static void __main_window___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda10_ (MainWindow* self);
static void __main_window___lambda10__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                         GtkWidget* widget,
                                                                         gpointer self);
static void main_window_finalize (GObject * obj);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

static gchar*
main_window_range_title (MainWindowRange self)
{
	gchar* result = NULL;
#line 50 "../src/MainWindow.vala"
	switch (self) {
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LOW:
#line 202 "MainWindow.c"
		{
			gchar* _tmp0_;
#line 52 "../src/MainWindow.vala"
			_tmp0_ = g_strdup (_ ("Very Low DPI"));
#line 52 "../src/MainWindow.vala"
			result = _tmp0_;
#line 52 "../src/MainWindow.vala"
			return result;
#line 211 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_LOW:
#line 215 "MainWindow.c"
		{
			gchar* _tmp1_;
#line 55 "../src/MainWindow.vala"
			_tmp1_ = g_strdup (_ ("Fairly Low DPI"));
#line 55 "../src/MainWindow.vala"
			result = _tmp1_;
#line 55 "../src/MainWindow.vala"
			return result;
#line 224 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
#line 228 "MainWindow.c"
		{
			gchar* _tmp2_;
#line 58 "../src/MainWindow.vala"
			_tmp2_ = g_strdup (_ ("Ideal for LoDPI"));
#line 58 "../src/MainWindow.vala"
			result = _tmp2_;
#line 58 "../src/MainWindow.vala"
			return result;
#line 237 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_UNCLEAR:
#line 245 "MainWindow.c"
		{
			gchar* _tmp3_;
#line 63 "../src/MainWindow.vala"
			_tmp3_ = g_strdup (_ ("Potentially Problematic"));
#line 63 "../src/MainWindow.vala"
			result = _tmp3_;
#line 63 "../src/MainWindow.vala"
			return result;
#line 254 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
#line 258 "MainWindow.c"
		{
			gchar* _tmp4_;
#line 66 "../src/MainWindow.vala"
			_tmp4_ = g_strdup (_ ("Ideal for HiDPI"));
#line 66 "../src/MainWindow.vala"
			result = _tmp4_;
#line 66 "../src/MainWindow.vala"
			return result;
#line 267 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
#line 271 "MainWindow.c"
		{
			gchar* _tmp5_;
#line 69 "../src/MainWindow.vala"
			_tmp5_ = g_strdup (_ ("Fairly High for HiDPI"));
#line 69 "../src/MainWindow.vala"
			result = _tmp5_;
#line 69 "../src/MainWindow.vala"
			return result;
#line 280 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIGH:
#line 284 "MainWindow.c"
		{
			gchar* _tmp6_;
#line 72 "../src/MainWindow.vala"
			_tmp6_ = g_strdup (_ ("Too High DPI"));
#line 72 "../src/MainWindow.vala"
			result = _tmp6_;
#line 72 "../src/MainWindow.vala"
			return result;
#line 293 "MainWindow.c"
		}
#line 50 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_INVALID:
#line 297 "MainWindow.c"
		{
			gchar* _tmp7_;
#line 75 "../src/MainWindow.vala"
			_tmp7_ = g_strdup (_ ("Analyze a Display"));
#line 75 "../src/MainWindow.vala"
			result = _tmp7_;
#line 75 "../src/MainWindow.vala"
			return result;
#line 306 "MainWindow.c"
		}
		default:
		{
#line 78 "../src/MainWindow.vala"
			g_assert_not_reached ();
#line 312 "MainWindow.c"
		}
	}
}

static gchar*
main_window_range_description (MainWindowRange self)
{
	gchar* result = NULL;
#line 83 "../src/MainWindow.vala"
	switch (self) {
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LOW:
#line 325 "MainWindow.c"
		{
			gchar* _tmp0_;
#line 85 "../src/MainWindow.vala"
			_tmp0_ = g_strdup (_ ("Text and UI are likely to be too big for typical viewing distances. Av" \
"oid if possible."));
#line 85 "../src/MainWindow.vala"
			result = _tmp0_;
#line 85 "../src/MainWindow.vala"
			return result;
#line 334 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_LOW:
#line 338 "MainWindow.c"
		{
			gchar* _tmp1_;
#line 88 "../src/MainWindow.vala"
			_tmp1_ = g_strdup (_ ("Text and UI might be too big for typical viewing distances, but it's l" \
"argely up to user preference and physical distance from the display."));
#line 88 "../src/MainWindow.vala"
			result = _tmp1_;
#line 88 "../src/MainWindow.vala"
			return result;
#line 347 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
#line 351 "MainWindow.c"
		{
			gchar* _tmp2_;
#line 91 "../src/MainWindow.vala"
			_tmp2_ = g_strdup (_ ("Not HiDPI, but a nice sweet spot. Text and UI should be legible at typ" \
"ical viewing distances."));
#line 91 "../src/MainWindow.vala"
			result = _tmp2_;
#line 91 "../src/MainWindow.vala"
			return result;
#line 360 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
#line 364 "MainWindow.c"
		{
			gchar* _tmp3_;
#line 94 "../src/MainWindow.vala"
			_tmp3_ = g_strdup (_ ("Relatively high resolution, but not quite HiDPI. Text and UI may be to" \
"o small by default, but forcing HiDPI would make them appear too large" \
". The experience may be slightly improved by increasing the text size."));
#line 94 "../src/MainWindow.vala"
			result = _tmp3_;
#line 94 "../src/MainWindow.vala"
			return result;
#line 373 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
#line 377 "MainWindow.c"
		{
			gchar* _tmp4_;
#line 97 "../src/MainWindow.vala"
			_tmp4_ = g_strdup (_ ("HiDPI by default, but text and UI may appear too large. Turning off Hi" \
"DPI and increasing the text size might help."));
#line 97 "../src/MainWindow.vala"
			result = _tmp4_;
#line 97 "../src/MainWindow.vala"
			return result;
#line 386 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
#line 390 "MainWindow.c"
		{
			gchar* _tmp5_;
#line 100 "../src/MainWindow.vala"
			_tmp5_ = g_strdup (_ ("Crisp HiDPI text and UI along with a readable size at typical viewing " \
"distances. This is the jackpot."));
#line 100 "../src/MainWindow.vala"
			result = _tmp5_;
#line 100 "../src/MainWindow.vala"
			return result;
#line 399 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
#line 403 "MainWindow.c"
		{
			gchar* _tmp6_;
#line 103 "../src/MainWindow.vala"
			_tmp6_ = g_strdup (_ ("Text and UI are likely to appear too small for typical viewing distanc" \
"es. Increasing the text size may help."));
#line 103 "../src/MainWindow.vala"
			result = _tmp6_;
#line 103 "../src/MainWindow.vala"
			return result;
#line 412 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIGH:
#line 416 "MainWindow.c"
		{
			gchar* _tmp7_;
#line 106 "../src/MainWindow.vala"
			_tmp7_ = g_strdup (_ ("Text and UI will appear too small for typical viewing distances."));
#line 106 "../src/MainWindow.vala"
			result = _tmp7_;
#line 106 "../src/MainWindow.vala"
			return result;
#line 425 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_UNCLEAR:
#line 429 "MainWindow.c"
		{
			gchar* _tmp8_;
#line 109 "../src/MainWindow.vala"
			_tmp8_ = g_strdup (_ ("This display is in a very tricky range and is not likely to work well " \
"with integer scaling out of the box."));
#line 109 "../src/MainWindow.vala"
			result = _tmp8_;
#line 109 "../src/MainWindow.vala"
			return result;
#line 438 "MainWindow.c"
		}
#line 83 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_INVALID:
#line 442 "MainWindow.c"
		{
			gchar* _tmp9_;
#line 112 "../src/MainWindow.vala"
			_tmp9_ = g_strdup (_ ("Enter details about a display to analyze it."));
#line 112 "../src/MainWindow.vala"
			result = _tmp9_;
#line 112 "../src/MainWindow.vala"
			return result;
#line 451 "MainWindow.c"
		}
		default:
		{
#line 115 "../src/MainWindow.vala"
			g_assert_not_reached ();
#line 457 "MainWindow.c"
		}
	}
}

static gchar*
main_window_range_icon (MainWindowRange self)
{
	gchar* result = NULL;
#line 120 "../src/MainWindow.vala"
	switch (self) {
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LOW:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIGH:
#line 472 "MainWindow.c"
		{
			gchar* _tmp0_;
#line 123 "../src/MainWindow.vala"
			_tmp0_ = g_strdup ("dialog-error");
#line 123 "../src/MainWindow.vala"
			result = _tmp0_;
#line 123 "../src/MainWindow.vala"
			return result;
#line 481 "MainWindow.c"
		}
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_LOW:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_UNCLEAR:
#line 493 "MainWindow.c"
		{
			gchar* _tmp1_;
#line 130 "../src/MainWindow.vala"
			_tmp1_ = g_strdup ("dialog-warning");
#line 130 "../src/MainWindow.vala"
			result = _tmp1_;
#line 130 "../src/MainWindow.vala"
			return result;
#line 502 "MainWindow.c"
		}
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
#line 508 "MainWindow.c"
		{
			gchar* _tmp2_;
#line 134 "../src/MainWindow.vala"
			_tmp2_ = g_strdup ("process-completed");
#line 134 "../src/MainWindow.vala"
			result = _tmp2_;
#line 134 "../src/MainWindow.vala"
			return result;
#line 517 "MainWindow.c"
		}
#line 120 "../src/MainWindow.vala"
		case MAIN_WINDOW_RANGE_INVALID:
#line 521 "MainWindow.c"
		{
			gchar* _tmp3_;
#line 137 "../src/MainWindow.vala"
			_tmp3_ = g_strdup ("dialog-information");
#line 137 "../src/MainWindow.vala"
			result = _tmp3_;
#line 137 "../src/MainWindow.vala"
			return result;
#line 530 "MainWindow.c"
		}
		default:
		{
#line 140 "../src/MainWindow.vala"
			g_assert_not_reached ();
#line 536 "MainWindow.c"
		}
	}
}

static GType
main_window_range_get_type (void)
{
	static volatile gsize main_window_range_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_range_type_id__volatile)) {
		static const GEnumValue values[] = {{MAIN_WINDOW_RANGE_LOW, "MAIN_WINDOW_RANGE_LOW", "low"}, {MAIN_WINDOW_RANGE_LODPI_LOW, "MAIN_WINDOW_RANGE_LODPI_LOW", "lodpi-low"}, {MAIN_WINDOW_RANGE_LODPI_IDEAL, "MAIN_WINDOW_RANGE_LODPI_IDEAL", "lodpi-ideal"}, {MAIN_WINDOW_RANGE_LODPI_HIGH, "MAIN_WINDOW_RANGE_LODPI_HIGH", "lodpi-high"}, {MAIN_WINDOW_RANGE_HIDPI_LOW, "MAIN_WINDOW_RANGE_HIDPI_LOW", "hidpi-low"}, {MAIN_WINDOW_RANGE_HIDPI_IDEAL, "MAIN_WINDOW_RANGE_HIDPI_IDEAL", "hidpi-ideal"}, {MAIN_WINDOW_RANGE_HIDPI_HIGH, "MAIN_WINDOW_RANGE_HIDPI_HIGH", "hidpi-high"}, {MAIN_WINDOW_RANGE_HIGH, "MAIN_WINDOW_RANGE_HIGH", "high"}, {MAIN_WINDOW_RANGE_UNCLEAR, "MAIN_WINDOW_RANGE_UNCLEAR", "unclear"}, {MAIN_WINDOW_RANGE_INVALID, "MAIN_WINDOW_RANGE_INVALID", "invalid"}, {0, NULL, NULL}};
		GType main_window_range_type_id;
		main_window_range_type_id = g_enum_register_static ("MainWindowRange", values);
		g_once_init_leave (&main_window_range_type_id__volatile, main_window_range_type_id);
	}
	return main_window_range_type_id__volatile;
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
#line 170 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 171 "../src/MainWindow.vala"
	self = (MainWindow*) g_object_new (object_type, "application", application, "border-width", 0, "icon-name", "com.github.cassidyjames.dippi", "resizable", FALSE, "title", _ ("Dippi"), "window-position", GTK_WIN_POS_CENTER, NULL);
#line 170 "../src/MainWindow.vala"
	return self;
#line 565 "MainWindow.c"
}

MainWindow*
main_window_new (GtkApplication* application)
{
#line 170 "../src/MainWindow.vala"
	return main_window_construct (TYPE_MAIN_WINDOW, application);
#line 573 "MainWindow.c"
}

static gint
main_window_recalculate_dpi (MainWindow* self,
                             gdouble inches,
                             gint width,
                             gint height)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
#line 404 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 405 "../src/MainWindow.vala"
	if (inches > ((gdouble) 0)) {
#line 405 "../src/MainWindow.vala"
		_tmp1_ = width > 0;
#line 593 "MainWindow.c"
	} else {
#line 405 "../src/MainWindow.vala"
		_tmp1_ = FALSE;
#line 597 "MainWindow.c"
	}
#line 405 "../src/MainWindow.vala"
	if (_tmp1_) {
#line 405 "../src/MainWindow.vala"
		_tmp0_ = height > 0;
#line 603 "MainWindow.c"
	} else {
#line 405 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 607 "MainWindow.c"
	}
#line 405 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 611 "MainWindow.c"
		gint calculated_dpi = 0;
		GtkLabel* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 406 "../src/MainWindow.vala"
		calculated_dpi = utils_dpi (inches, width, height);
#line 408 "../src/MainWindow.vala"
		_tmp2_ = self->priv->dpi_result_label;
#line 408 "../src/MainWindow.vala"
		_tmp3_ = g_strdup_printf (_ ("%d DPI"), calculated_dpi);
#line 408 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 408 "../src/MainWindow.vala"
		gtk_label_set_label (_tmp2_, _tmp4_);
#line 408 "../src/MainWindow.vala"
		_g_free0 (_tmp4_);
#line 410 "../src/MainWindow.vala"
		main_window_recalculate_logical_resolution (self, width, height, calculated_dpi);
#line 411 "../src/MainWindow.vala"
		result = calculated_dpi;
#line 411 "../src/MainWindow.vala"
		return result;
#line 634 "MainWindow.c"
	}
#line 414 "../src/MainWindow.vala"
	_tmp5_ = self->priv->dpi_result_label;
#line 414 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp5_, "");
#line 415 "../src/MainWindow.vala"
	_tmp6_ = self->priv->logical_resolution_label;
#line 415 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp6_, "");
#line 416 "../src/MainWindow.vala"
	result = 0;
#line 416 "../src/MainWindow.vala"
	return result;
#line 648 "MainWindow.c"
}

static void
main_window_recalculate_aspect (MainWindow* self,
                                gint width,
                                gint height)
{
	gboolean _tmp0_ = FALSE;
#line 419 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/MainWindow.vala"
	if (width > 0) {
#line 420 "../src/MainWindow.vala"
		_tmp0_ = height > 0;
#line 663 "MainWindow.c"
	} else {
#line 420 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 667 "MainWindow.c"
	}
#line 420 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 671 "MainWindow.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 421 "../src/MainWindow.vala"
		self->priv->aspect_width = width / utils_greatest_common_divisor (width, height);
#line 422 "../src/MainWindow.vala"
		self->priv->aspect_height = height / utils_greatest_common_divisor (width, height);
#line 423 "../src/MainWindow.vala"
		_tmp1_ = self->priv->aspect_result_label;
#line 423 "../src/MainWindow.vala"
		_tmp2_ = g_strdup_printf ("%i", self->priv->aspect_width);
#line 423 "../src/MainWindow.vala"
		_tmp3_ = _tmp2_;
#line 423 "../src/MainWindow.vala"
		_tmp4_ = g_strconcat (_tmp3_, _ (":"), NULL);
#line 423 "../src/MainWindow.vala"
		_tmp5_ = _tmp4_;
#line 423 "../src/MainWindow.vala"
		_tmp6_ = g_strdup_printf ("%i", self->priv->aspect_height);
#line 423 "../src/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 423 "../src/MainWindow.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 423 "../src/MainWindow.vala"
		_tmp9_ = _tmp8_;
#line 423 "../src/MainWindow.vala"
		gtk_label_set_label (_tmp1_, _tmp9_);
#line 423 "../src/MainWindow.vala"
		_g_free0 (_tmp9_);
#line 423 "../src/MainWindow.vala"
		_g_free0 (_tmp7_);
#line 423 "../src/MainWindow.vala"
		_g_free0 (_tmp5_);
#line 423 "../src/MainWindow.vala"
		_g_free0 (_tmp3_);
#line 713 "MainWindow.c"
	} else {
		GtkLabel* _tmp10_;
#line 425 "../src/MainWindow.vala"
		_tmp10_ = self->priv->aspect_result_label;
#line 425 "../src/MainWindow.vala"
		gtk_label_set_label (_tmp10_, "");
#line 720 "MainWindow.c"
	}
}

static void
main_window_recalculate_logical_resolution (MainWindow* self,
                                            gint width,
                                            gint height,
                                            gint dpi)
{
	gboolean _tmp0_ = FALSE;
#line 429 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/MainWindow.vala"
	if (width > 0) {
#line 430 "../src/MainWindow.vala"
		_tmp0_ = height > 0;
#line 737 "MainWindow.c"
	} else {
#line 430 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 741 "MainWindow.c"
	}
#line 430 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 431 "../src/MainWindow.vala"
		if (dpi >= MAIN_WINDOW_DPI_INFER_HIDPI) {
#line 747 "MainWindow.c"
			gint scaling_factor = 0;
			gint logical_width = 0;
			gint logical_height = 0;
			GtkLabel* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 432 "../src/MainWindow.vala"
			scaling_factor = 2;
#line 433 "../src/MainWindow.vala"
			logical_width = (gint) (width / scaling_factor);
#line 434 "../src/MainWindow.vala"
			logical_height = (gint) (height / scaling_factor);
#line 436 "../src/MainWindow.vala"
			_tmp1_ = self->priv->logical_resolution_label;
#line 436 "../src/MainWindow.vala"
			_tmp2_ = g_strdup_printf ("%d×%d@%dx", logical_width, logical_height, scaling_factor);
#line 436 "../src/MainWindow.vala"
			_tmp3_ = _tmp2_;
#line 436 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp1_, _tmp3_);
#line 436 "../src/MainWindow.vala"
			_g_free0 (_tmp3_);
#line 770 "MainWindow.c"
		} else {
			GtkLabel* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 442 "../src/MainWindow.vala"
			_tmp4_ = self->priv->logical_resolution_label;
#line 442 "../src/MainWindow.vala"
			_tmp5_ = g_strdup_printf ("%d×%d", width, height);
#line 442 "../src/MainWindow.vala"
			_tmp6_ = _tmp5_;
#line 442 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp4_, _tmp6_);
#line 442 "../src/MainWindow.vala"
			_g_free0 (_tmp6_);
#line 785 "MainWindow.c"
		}
	} else {
		GtkLabel* _tmp7_;
#line 445 "../src/MainWindow.vala"
		_tmp7_ = self->priv->logical_resolution_label;
#line 445 "../src/MainWindow.vala"
		gtk_label_set_label (_tmp7_, "");
#line 793 "MainWindow.c"
	}
}

static void
main_window_assess_dpi (MainWindow* self,
                        gdouble calculated_dpi,
                        UtilsDisplayType display_type)
{
	gint ideal_dpi = 0;
	gint ideal_range = 0;
	gint unclear_range = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkImage* _tmp2_;
	MainWindowRange _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	MainWindowRange _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkLabel* _tmp10_;
	MainWindowRange _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 449 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/MainWindow.vala"
	ideal_dpi = MAIN_WINDOW_INTERNAL_IDEAL_DPI;
#line 451 "../src/MainWindow.vala"
	ideal_range = MAIN_WINDOW_INTERNAL_IDEAL_RANGE;
#line 452 "../src/MainWindow.vala"
	unclear_range = MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE;
#line 454 "../src/MainWindow.vala"
	if (display_type == UTILS_DISPLAY_TYPE_EXTERNAL) {
#line 455 "../src/MainWindow.vala"
		ideal_dpi = MAIN_WINDOW_EXTERNAL_IDEAL_DPI;
#line 456 "../src/MainWindow.vala"
		ideal_range = MAIN_WINDOW_EXTERNAL_IDEAL_RANGE;
#line 457 "../src/MainWindow.vala"
		unclear_range = MAIN_WINDOW_EXTERNAL_UNCLEAR_RANGE;
#line 835 "MainWindow.c"
	}
#line 460 "../src/MainWindow.vala"
	if (self->priv->inches == ((gdouble) 0)) {
#line 460 "../src/MainWindow.vala"
		_tmp1_ = TRUE;
#line 841 "MainWindow.c"
	} else {
#line 460 "../src/MainWindow.vala"
		_tmp1_ = self->priv->width == 0;
#line 845 "MainWindow.c"
	}
#line 460 "../src/MainWindow.vala"
	if (_tmp1_) {
#line 460 "../src/MainWindow.vala"
		_tmp0_ = TRUE;
#line 851 "MainWindow.c"
	} else {
#line 460 "../src/MainWindow.vala"
		_tmp0_ = self->priv->height == 0;
#line 855 "MainWindow.c"
	}
#line 460 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 461 "../src/MainWindow.vala"
		self->priv->range = MAIN_WINDOW_RANGE_INVALID;
#line 861 "MainWindow.c"
	} else {
#line 464 "../src/MainWindow.vala"
		if (calculated_dpi < ((gdouble) ((ideal_dpi - ideal_range) - MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE))) {
#line 465 "../src/MainWindow.vala"
			self->priv->range = MAIN_WINDOW_RANGE_LOW;
#line 867 "MainWindow.c"
		} else {
#line 468 "../src/MainWindow.vala"
			if (calculated_dpi < ((gdouble) (ideal_dpi - ideal_range))) {
#line 469 "../src/MainWindow.vala"
				self->priv->range = MAIN_WINDOW_RANGE_LODPI_LOW;
#line 873 "MainWindow.c"
			} else {
#line 472 "../src/MainWindow.vala"
				if (calculated_dpi <= ((gdouble) (ideal_dpi + ideal_range))) {
#line 473 "../src/MainWindow.vala"
					self->priv->range = MAIN_WINDOW_RANGE_LODPI_IDEAL;
#line 879 "MainWindow.c"
				} else {
#line 476 "../src/MainWindow.vala"
					if (calculated_dpi <= ((gdouble) ((ideal_dpi + ideal_range) + unclear_range))) {
#line 477 "../src/MainWindow.vala"
						self->priv->range = MAIN_WINDOW_RANGE_LODPI_HIGH;
#line 885 "MainWindow.c"
					} else {
#line 480 "../src/MainWindow.vala"
						if (calculated_dpi < ((gdouble) MAIN_WINDOW_DPI_INFER_HIDPI)) {
#line 481 "../src/MainWindow.vala"
							self->priv->range = MAIN_WINDOW_RANGE_UNCLEAR;
#line 891 "MainWindow.c"
						} else {
#line 484 "../src/MainWindow.vala"
							if (calculated_dpi < ((gdouble) (((ideal_dpi - ideal_range) - unclear_range) * 2))) {
#line 485 "../src/MainWindow.vala"
								self->priv->range = MAIN_WINDOW_RANGE_UNCLEAR;
#line 897 "MainWindow.c"
							} else {
#line 488 "../src/MainWindow.vala"
								if (calculated_dpi < ((gdouble) ((ideal_dpi - ideal_range) * 2))) {
#line 489 "../src/MainWindow.vala"
									self->priv->range = MAIN_WINDOW_RANGE_HIDPI_LOW;
#line 903 "MainWindow.c"
								} else {
#line 492 "../src/MainWindow.vala"
									if (calculated_dpi <= ((gdouble) ((ideal_dpi + ideal_range) * 2))) {
#line 493 "../src/MainWindow.vala"
										self->priv->range = MAIN_WINDOW_RANGE_HIDPI_IDEAL;
#line 909 "MainWindow.c"
									} else {
#line 496 "../src/MainWindow.vala"
										if (calculated_dpi <= ((gdouble) (((ideal_dpi + ideal_range) + unclear_range) * 2))) {
#line 497 "../src/MainWindow.vala"
											self->priv->range = MAIN_WINDOW_RANGE_HIDPI_HIGH;
#line 915 "MainWindow.c"
										} else {
#line 500 "../src/MainWindow.vala"
											if (calculated_dpi > ((gdouble) (((ideal_dpi + ideal_range) + unclear_range) * 2))) {
#line 501 "../src/MainWindow.vala"
												self->priv->range = MAIN_WINDOW_RANGE_HIGH;
#line 921 "MainWindow.c"
											} else {
#line 505 "../src/MainWindow.vala"
												self->priv->range = MAIN_WINDOW_RANGE_INVALID;
#line 925 "MainWindow.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 508 "../src/MainWindow.vala"
	_tmp2_ = self->priv->range_icon;
#line 508 "../src/MainWindow.vala"
	_tmp3_ = self->priv->range;
#line 508 "../src/MainWindow.vala"
	_tmp4_ = main_window_range_icon (_tmp3_);
#line 508 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 508 "../src/MainWindow.vala"
	g_object_set (_tmp2_, "icon-name", _tmp5_, NULL);
#line 508 "../src/MainWindow.vala"
	_g_free0 (_tmp5_);
#line 509 "../src/MainWindow.vala"
	_tmp6_ = self->priv->range_title_label;
#line 509 "../src/MainWindow.vala"
	_tmp7_ = self->priv->range;
#line 509 "../src/MainWindow.vala"
	_tmp8_ = main_window_range_title (_tmp7_);
#line 509 "../src/MainWindow.vala"
	_tmp9_ = _tmp8_;
#line 509 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp6_, _tmp9_);
#line 509 "../src/MainWindow.vala"
	_g_free0 (_tmp9_);
#line 510 "../src/MainWindow.vala"
	_tmp10_ = self->priv->range_description_label;
#line 510 "../src/MainWindow.vala"
	_tmp11_ = self->priv->range;
#line 510 "../src/MainWindow.vala"
	_tmp12_ = main_window_range_description (_tmp11_);
#line 510 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 510 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp10_, _tmp13_);
#line 510 "../src/MainWindow.vala"
	_g_free0 (_tmp13_);
#line 973 "MainWindow.c"
}

static UtilsDisplayType
main_window_infer_display_type (MainWindow* self,
                                gdouble inches)
{
	UtilsDisplayType result = 0;
	UtilsDisplayType _tmp2_;
#line 513 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 514 "../src/MainWindow.vala"
	self->priv->is_default_display_type = TRUE;
#line 516 "../src/MainWindow.vala"
	if (inches < ((gdouble) 18)) {
#line 988 "MainWindow.c"
		GraniteWidgetsModeButton* _tmp0_;
#line 517 "../src/MainWindow.vala"
		self->priv->display_type = UTILS_DISPLAY_TYPE_INTERNAL;
#line 518 "../src/MainWindow.vala"
		_tmp0_ = self->priv->type_modebutton;
#line 518 "../src/MainWindow.vala"
		granite_widgets_mode_button_set_selected (_tmp0_, 0);
#line 996 "MainWindow.c"
	} else {
		GraniteWidgetsModeButton* _tmp1_;
#line 520 "../src/MainWindow.vala"
		self->priv->display_type = UTILS_DISPLAY_TYPE_EXTERNAL;
#line 521 "../src/MainWindow.vala"
		_tmp1_ = self->priv->type_modebutton;
#line 521 "../src/MainWindow.vala"
		granite_widgets_mode_button_set_selected (_tmp1_, 1);
#line 1005 "MainWindow.c"
	}
#line 524 "../src/MainWindow.vala"
	_tmp2_ = self->priv->display_type;
#line 524 "../src/MainWindow.vala"
	result = _tmp2_;
#line 524 "../src/MainWindow.vala"
	return result;
#line 1013 "MainWindow.c"
}

static void
main_window_set_display_icon (MainWindow* self)
{
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	UtilsDisplayType _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 527 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/MainWindow.vala"
	_tmp0_ = self->priv->diagram;
#line 528 "../src/MainWindow.vala"
	_tmp1_ = self->priv->direction;
#line 528 "../src/MainWindow.vala"
	_tmp2_ = g_strconcat ("display-measure-", _tmp1_, NULL);
#line 528 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 528 "../src/MainWindow.vala"
	_tmp4_ = self->priv->display_type;
#line 528 "../src/MainWindow.vala"
	_tmp5_ = utils_display_type_icon_suffix (_tmp4_);
#line 528 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 528 "../src/MainWindow.vala"
	_tmp7_ = g_strconcat (_tmp3_, _tmp6_, NULL);
#line 528 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 528 "../src/MainWindow.vala"
	g_object_set (_tmp0_, "icon-name", _tmp8_, NULL);
#line 528 "../src/MainWindow.vala"
	_g_free0 (_tmp8_);
#line 528 "../src/MainWindow.vala"
	_g_free0 (_tmp6_);
#line 528 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 1056 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 187 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 1064 "MainWindow.c"
}

static gboolean
_main_window___lambda4_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 203 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 204 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("diagonal");
#line 204 "../src/MainWindow.vala"
	_g_free0 (self->priv->direction);
#line 204 "../src/MainWindow.vala"
	self->priv->direction = _tmp0_;
#line 205 "../src/MainWindow.vala"
	main_window_set_display_icon (self);
#line 206 "../src/MainWindow.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
#line 206 "../src/MainWindow.vala"
	result = _tmp1_;
#line 206 "../src/MainWindow.vala"
	return result;
#line 1090 "MainWindow.c"
}

static gboolean
__main_window___lambda4__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda4_ ((MainWindow*) self, event);
#line 203 "../src/MainWindow.vala"
	return result;
#line 1102 "MainWindow.c"
}

static gboolean
_main_window___lambda5_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 216 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 217 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("horizontal");
#line 217 "../src/MainWindow.vala"
	_g_free0 (self->priv->direction);
#line 217 "../src/MainWindow.vala"
	self->priv->direction = _tmp0_;
#line 218 "../src/MainWindow.vala"
	main_window_set_display_icon (self);
#line 219 "../src/MainWindow.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
#line 219 "../src/MainWindow.vala"
	result = _tmp1_;
#line 219 "../src/MainWindow.vala"
	return result;
#line 1128 "MainWindow.c"
}

static gboolean
__main_window___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda5_ ((MainWindow*) self, event);
#line 216 "../src/MainWindow.vala"
	return result;
#line 1140 "MainWindow.c"
}

static gboolean
_main_window___lambda6_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 226 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 227 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("vertical");
#line 227 "../src/MainWindow.vala"
	_g_free0 (self->priv->direction);
#line 227 "../src/MainWindow.vala"
	self->priv->direction = _tmp0_;
#line 228 "../src/MainWindow.vala"
	main_window_set_display_icon (self);
#line 229 "../src/MainWindow.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
#line 229 "../src/MainWindow.vala"
	result = _tmp1_;
#line 229 "../src/MainWindow.vala"
	return result;
#line 1166 "MainWindow.c"
}

static gboolean
__main_window___lambda6__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda6_ ((MainWindow*) self, event);
#line 226 "../src/MainWindow.vala"
	return result;
#line 1178 "MainWindow.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 1191 "MainWindow.c"
}

static void
_main_window___lambda7_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 284 "../src/MainWindow.vala"
	_tmp0_ = self->priv->diag_entry;
#line 284 "../src/MainWindow.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 284 "../src/MainWindow.vala"
	self->priv->inches = double_parse (_tmp1_);
#line 285 "../src/MainWindow.vala"
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), main_window_infer_display_type (self, self->priv->inches));
#line 1207 "MainWindow.c"
}

static void
__main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 283 "../src/MainWindow.vala"
	_main_window___lambda7_ ((MainWindow*) self);
#line 1216 "MainWindow.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 1247 "MainWindow.c"
}

static void
_main_window___lambda8_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	UtilsDisplayType _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkEntry* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 292 "../src/MainWindow.vala"
	_tmp0_ = self->priv->width_entry;
#line 292 "../src/MainWindow.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 292 "../src/MainWindow.vala"
	self->priv->width = atoi (_tmp1_);
#line 294 "../src/MainWindow.vala"
	self->priv->is_default_width = FALSE;
#line 296 "../src/MainWindow.vala"
	main_window_recalculate_aspect (self, self->priv->width, self->priv->height);
#line 297 "../src/MainWindow.vala"
	_tmp2_ = self->priv->display_type;
#line 297 "../src/MainWindow.vala"
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), _tmp2_);
#line 302 "../src/MainWindow.vala"
	_tmp4_ = self->priv->height_entry;
#line 302 "../src/MainWindow.vala"
	g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 302 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 302 "../src/MainWindow.vala"
	if (!_tmp6_) {
#line 1282 "MainWindow.c"
		gboolean _tmp7_ = FALSE;
#line 302 "../src/MainWindow.vala"
		if (self->priv->is_default_height) {
#line 302 "../src/MainWindow.vala"
			_tmp7_ = TRUE;
#line 1288 "MainWindow.c"
		} else {
#line 302 "../src/MainWindow.vala"
			_tmp7_ = self->priv->height == 0;
#line 1292 "MainWindow.c"
		}
#line 302 "../src/MainWindow.vala"
		_tmp3_ = _tmp7_;
#line 1296 "MainWindow.c"
	} else {
#line 302 "../src/MainWindow.vala"
		_tmp3_ = FALSE;
#line 1300 "MainWindow.c"
	}
#line 302 "../src/MainWindow.vala"
	if (_tmp3_) {
#line 1304 "MainWindow.c"
		gdouble calculated_height = 0.0;
		GtkEntry* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 303 "../src/MainWindow.vala"
		calculated_height = round ((gdouble) ((self->priv->width * MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT) / MAIN_WINDOW_DEFAULT_ASPECT_WIDTH));
#line 308 "../src/MainWindow.vala"
		_tmp8_ = self->priv->height_entry;
#line 308 "../src/MainWindow.vala"
		_tmp9_ = double_to_string (calculated_height);
#line 308 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 308 "../src/MainWindow.vala"
		gtk_entry_set_text (_tmp8_, _tmp10_);
#line 308 "../src/MainWindow.vala"
		_g_free0 (_tmp10_);
#line 309 "../src/MainWindow.vala"
		self->priv->is_default_height = TRUE;
#line 1323 "MainWindow.c"
	}
}

static void
__main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 291 "../src/MainWindow.vala"
	_main_window___lambda8_ ((MainWindow*) self);
#line 1333 "MainWindow.c"
}

static void
_main_window___lambda9_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	UtilsDisplayType _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkEntry* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 314 "../src/MainWindow.vala"
	_tmp0_ = self->priv->height_entry;
#line 314 "../src/MainWindow.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 314 "../src/MainWindow.vala"
	self->priv->height = atoi (_tmp1_);
#line 316 "../src/MainWindow.vala"
	self->priv->is_default_height = FALSE;
#line 318 "../src/MainWindow.vala"
	main_window_recalculate_aspect (self, self->priv->width, self->priv->height);
#line 319 "../src/MainWindow.vala"
	_tmp2_ = self->priv->display_type;
#line 319 "../src/MainWindow.vala"
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), _tmp2_);
#line 324 "../src/MainWindow.vala"
	_tmp4_ = self->priv->width_entry;
#line 324 "../src/MainWindow.vala"
	g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 324 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 324 "../src/MainWindow.vala"
	if (!_tmp6_) {
#line 1368 "MainWindow.c"
		gboolean _tmp7_ = FALSE;
#line 324 "../src/MainWindow.vala"
		if (self->priv->is_default_width) {
#line 324 "../src/MainWindow.vala"
			_tmp7_ = TRUE;
#line 1374 "MainWindow.c"
		} else {
#line 324 "../src/MainWindow.vala"
			_tmp7_ = self->priv->width == 0;
#line 1378 "MainWindow.c"
		}
#line 324 "../src/MainWindow.vala"
		_tmp3_ = _tmp7_;
#line 1382 "MainWindow.c"
	} else {
#line 324 "../src/MainWindow.vala"
		_tmp3_ = FALSE;
#line 1386 "MainWindow.c"
	}
#line 324 "../src/MainWindow.vala"
	if (_tmp3_) {
#line 1390 "MainWindow.c"
		gdouble calculated_width = 0.0;
		GtkEntry* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 325 "../src/MainWindow.vala"
		calculated_width = round ((gdouble) ((self->priv->height * MAIN_WINDOW_DEFAULT_ASPECT_WIDTH) / MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT));
#line 330 "../src/MainWindow.vala"
		_tmp8_ = self->priv->width_entry;
#line 330 "../src/MainWindow.vala"
		_tmp9_ = double_to_string (calculated_width);
#line 330 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 330 "../src/MainWindow.vala"
		gtk_entry_set_text (_tmp8_, _tmp10_);
#line 330 "../src/MainWindow.vala"
		_g_free0 (_tmp10_);
#line 331 "../src/MainWindow.vala"
		self->priv->is_default_width = TRUE;
#line 1409 "MainWindow.c"
	}
}

static void
__main_window___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 313 "../src/MainWindow.vala"
	_main_window___lambda9_ ((MainWindow*) self);
#line 1419 "MainWindow.c"
}

static void
_main_window___lambda10_ (MainWindow* self)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	UtilsDisplayType _tmp3_;
#line 336 "../src/MainWindow.vala"
	_tmp0_ = self->priv->type_modebutton;
#line 336 "../src/MainWindow.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 336 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 336 "../src/MainWindow.vala"
	switch (_tmp2_) {
#line 336 "../src/MainWindow.vala"
		case 0:
#line 1439 "MainWindow.c"
		{
#line 338 "../src/MainWindow.vala"
			self->priv->display_type = UTILS_DISPLAY_TYPE_INTERNAL;
#line 339 "../src/MainWindow.vala"
			break;
#line 1445 "MainWindow.c"
		}
#line 336 "../src/MainWindow.vala"
		case 1:
#line 1449 "MainWindow.c"
		{
#line 342 "../src/MainWindow.vala"
			self->priv->display_type = UTILS_DISPLAY_TYPE_EXTERNAL;
#line 343 "../src/MainWindow.vala"
			break;
#line 1455 "MainWindow.c"
		}
		default:
		{
#line 346 "../src/MainWindow.vala"
			g_assert_not_reached ();
#line 1461 "MainWindow.c"
		}
	}
#line 349 "../src/MainWindow.vala"
	_tmp3_ = self->priv->display_type;
#line 349 "../src/MainWindow.vala"
	main_window_assess_dpi (self, (gdouble) utils_dpi (self->priv->inches, self->priv->width, self->priv->height), _tmp3_);
#line 350 "../src/MainWindow.vala"
	main_window_set_display_icon (self);
#line 1470 "MainWindow.c"
}

static void
__main_window___lambda10__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                    GtkWidget* widget,
                                                                    gpointer self)
{
#line 335 "../src/MainWindow.vala"
	_main_window___lambda10_ ((MainWindow*) self);
#line 1480 "MainWindow.c"
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkHeaderBar* header = NULL;
	GtkHeaderBar* _tmp2_;
	GtkHeaderBar* _tmp3_;
	GtkStyleContext* header_context = NULL;
	GtkHeaderBar* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* diag_label = NULL;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkLabel* res_label = NULL;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
	GtkEntry* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
	GtkLabel* x_label = NULL;
	GtkLabel* _tmp32_;
	GtkLabel* px_label = NULL;
	GtkLabel* _tmp33_;
	GtkLabel* inches_label = NULL;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* type_label = NULL;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GraniteWidgetsModeButton* _tmp38_;
	GraniteWidgetsModeButton* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	GraniteWidgetsModeButton* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	GtkImage* _tmp57_;
	GtkImage* _tmp58_;
	GtkImage* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	GtkLabel* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkLabel* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkLabel* _tmp73_;
	GtkLabel* _tmp74_;
	GtkLabel* _tmp75_;
	GtkLabel* _tmp76_;
	GtkLabel* _tmp77_;
	GtkLabel* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	GtkEntry* _tmp81_;
	GtkEntry* _tmp82_;
	GtkEntry* _tmp83_;
	GraniteWidgetsModeButton* _tmp84_;
	GtkGrid* data_grid = NULL;
	GtkGrid* _tmp85_;
	GtkGrid* _tmp86_;
	GtkGrid* _tmp87_;
	GtkGrid* _tmp88_;
	GtkGrid* _tmp89_;
	GtkGrid* _tmp90_;
	GtkStyleContext* _tmp91_;
	GtkGrid* _tmp92_;
	GtkImage* _tmp93_;
	GtkGrid* _tmp94_;
	GtkLabel* _tmp95_;
	GtkGrid* _tmp96_;
	GtkEntry* _tmp97_;
	GtkGrid* _tmp98_;
	GtkLabel* _tmp99_;
	GtkGrid* _tmp100_;
	GtkLabel* _tmp101_;
	GtkGrid* _tmp102_;
	GtkEntry* _tmp103_;
	GtkGrid* _tmp104_;
	GtkLabel* _tmp105_;
	GtkGrid* _tmp106_;
	GtkEntry* _tmp107_;
	GtkGrid* _tmp108_;
	GtkLabel* _tmp109_;
	GtkGrid* _tmp110_;
	GtkLabel* _tmp111_;
	GtkGrid* _tmp112_;
	GraniteWidgetsModeButton* _tmp113_;
	GtkGrid* assessment_grid = NULL;
	GtkGrid* _tmp114_;
	GtkGrid* _tmp115_;
	GtkGrid* _tmp116_;
	GtkGrid* _tmp117_;
	GtkGrid* _tmp118_;
	GtkGrid* _tmp119_;
	GtkGrid* _tmp120_;
	GtkGrid* _tmp121_;
	GtkStyleContext* _tmp122_;
	GtkGrid* _tmp123_;
	GtkImage* _tmp124_;
	GtkGrid* _tmp125_;
	GtkLabel* _tmp126_;
	GtkGrid* _tmp127_;
	GtkLabel* _tmp128_;
	GtkGrid* _tmp129_;
	GtkLabel* _tmp130_;
	GtkGrid* _tmp131_;
	GtkLabel* _tmp132_;
	GtkGrid* _tmp133_;
	GtkLabel* _tmp134_;
	GtkGrid* main_layout = NULL;
	GtkGrid* _tmp135_;
	GtkGrid* _tmp136_;
	GtkGrid* _tmp137_;
	GtkGrid* _tmp138_;
	GtkGrid* _tmp139_;
	GtkGrid* _tmp140_;
	GtkGrid* _tmp141_;
	GtkGrid* _tmp142_;
	GtkGrid* _tmp143_;
	GtkEntry* _tmp144_;
	GtkStyleContext* _tmp145_;
	GtkStyleContext* _tmp146_;
	GtkHeaderBar* _tmp147_;
	GtkGrid* _tmp148_;
#line 181 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
#line 181 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 181 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 182 "../src/MainWindow.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 182 "../src/MainWindow.vala"
	default_theme = _tmp0_;
#line 183 "../src/MainWindow.vala"
	_tmp1_ = default_theme;
#line 183 "../src/MainWindow.vala"
	gtk_icon_theme_add_resource_path (_tmp1_, "/com/github/cassidyjames/dippi");
#line 185 "../src/MainWindow.vala"
	_tmp2_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 185 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 185 "../src/MainWindow.vala"
	header = _tmp2_;
#line 186 "../src/MainWindow.vala"
	_tmp3_ = header;
#line 186 "../src/MainWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp3_, TRUE);
#line 187 "../src/MainWindow.vala"
	_tmp4_ = header;
#line 187 "../src/MainWindow.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 187 "../src/MainWindow.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 187 "../src/MainWindow.vala"
	header_context = _tmp6_;
#line 188 "../src/MainWindow.vala"
	_tmp7_ = header_context;
#line 188 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp7_, "titlebar");
#line 189 "../src/MainWindow.vala"
	_tmp8_ = header_context;
#line 189 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp8_, "default-decoration");
#line 190 "../src/MainWindow.vala"
	_tmp9_ = header_context;
#line 190 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp9_, GTK_STYLE_CLASS_FLAT);
#line 192 "../src/MainWindow.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("com.github.cassidyjames.dippi", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 192 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 192 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->diagram);
#line 192 "../src/MainWindow.vala"
	self->priv->diagram = _tmp10_;
#line 193 "../src/MainWindow.vala"
	_tmp11_ = self->priv->diagram;
#line 193 "../src/MainWindow.vala"
	gtk_image_set_pixel_size (_tmp11_, 128);
#line 194 "../src/MainWindow.vala"
	_tmp12_ = self->priv->diagram;
#line 194 "../src/MainWindow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp12_, 12);
#line 196 "../src/MainWindow.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (_ ("Diagonal size:"));
#line 196 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 196 "../src/MainWindow.vala"
	diag_label = _tmp13_;
#line 197 "../src/MainWindow.vala"
	_tmp14_ = diag_label;
#line 197 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_END);
#line 199 "../src/MainWindow.vala"
	_tmp15_ = (GtkEntry*) gtk_entry_new ();
#line 199 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 199 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->diag_entry);
#line 199 "../src/MainWindow.vala"
	self->priv->diag_entry = _tmp15_;
#line 200 "../src/MainWindow.vala"
	_tmp16_ = self->priv->diag_entry;
#line 200 "../src/MainWindow.vala"
	gtk_entry_set_max_length (_tmp16_, 5);
#line 201 "../src/MainWindow.vala"
	_tmp17_ = self->priv->diag_entry;
#line 201 "../src/MainWindow.vala"
	gtk_entry_set_max_width_chars (_tmp17_, 5);
#line 202 "../src/MainWindow.vala"
	_tmp18_ = self->priv->diag_entry;
#line 202 "../src/MainWindow.vala"
	gtk_entry_set_width_chars (_tmp18_, 5);
#line 203 "../src/MainWindow.vala"
	_tmp19_ = self->priv->diag_entry;
#line 203 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp19_, "focus-in-event", (GCallback) __main_window___lambda4__gtk_widget_focus_in_event, self, 0);
#line 209 "../src/MainWindow.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_ ("Resolution:"));
#line 209 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp20_);
#line 209 "../src/MainWindow.vala"
	res_label = _tmp20_;
#line 210 "../src/MainWindow.vala"
	_tmp21_ = res_label;
#line 210 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
#line 212 "../src/MainWindow.vala"
	_tmp22_ = (GtkEntry*) gtk_entry_new ();
#line 212 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp22_);
#line 212 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->width_entry);
#line 212 "../src/MainWindow.vala"
	self->priv->width_entry = _tmp22_;
#line 213 "../src/MainWindow.vala"
	_tmp23_ = self->priv->width_entry;
#line 213 "../src/MainWindow.vala"
	gtk_entry_set_max_length (_tmp23_, 5);
#line 214 "../src/MainWindow.vala"
	_tmp24_ = self->priv->width_entry;
#line 214 "../src/MainWindow.vala"
	gtk_entry_set_max_width_chars (_tmp24_, 5);
#line 215 "../src/MainWindow.vala"
	_tmp25_ = self->priv->width_entry;
#line 215 "../src/MainWindow.vala"
	gtk_entry_set_width_chars (_tmp25_, 5);
#line 216 "../src/MainWindow.vala"
	_tmp26_ = self->priv->width_entry;
#line 216 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp26_, "focus-in-event", (GCallback) __main_window___lambda5__gtk_widget_focus_in_event, self, 0);
#line 222 "../src/MainWindow.vala"
	_tmp27_ = (GtkEntry*) gtk_entry_new ();
#line 222 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp27_);
#line 222 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->height_entry);
#line 222 "../src/MainWindow.vala"
	self->priv->height_entry = _tmp27_;
#line 223 "../src/MainWindow.vala"
	_tmp28_ = self->priv->height_entry;
#line 223 "../src/MainWindow.vala"
	gtk_entry_set_max_length (_tmp28_, 5);
#line 224 "../src/MainWindow.vala"
	_tmp29_ = self->priv->height_entry;
#line 224 "../src/MainWindow.vala"
	gtk_entry_set_max_width_chars (_tmp29_, 5);
#line 225 "../src/MainWindow.vala"
	_tmp30_ = self->priv->height_entry;
#line 225 "../src/MainWindow.vala"
	gtk_entry_set_width_chars (_tmp30_, 5);
#line 226 "../src/MainWindow.vala"
	_tmp31_ = self->priv->height_entry;
#line 226 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp31_, "focus-in-event", (GCallback) __main_window___lambda6__gtk_widget_focus_in_event, self, 0);
#line 232 "../src/MainWindow.vala"
	_tmp32_ = (GtkLabel*) gtk_label_new (_ ("×"));
#line 232 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp32_);
#line 232 "../src/MainWindow.vala"
	x_label = _tmp32_;
#line 233 "../src/MainWindow.vala"
	_tmp33_ = (GtkLabel*) gtk_label_new (_ ("px"));
#line 233 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp33_);
#line 233 "../src/MainWindow.vala"
	px_label = _tmp33_;
#line 235 "../src/MainWindow.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (_ ("inches"));
#line 235 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp34_);
#line 235 "../src/MainWindow.vala"
	inches_label = _tmp34_;
#line 236 "../src/MainWindow.vala"
	_tmp35_ = inches_label;
#line 236 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp35_, GTK_ALIGN_START);
#line 238 "../src/MainWindow.vala"
	_tmp36_ = (GtkLabel*) gtk_label_new (_ ("Type:"));
#line 238 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 238 "../src/MainWindow.vala"
	type_label = _tmp36_;
#line 239 "../src/MainWindow.vala"
	_tmp37_ = type_label;
#line 239 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp37_, GTK_ALIGN_END);
#line 241 "../src/MainWindow.vala"
	_tmp38_ = granite_widgets_mode_button_new ();
#line 241 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp38_);
#line 241 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->type_modebutton);
#line 241 "../src/MainWindow.vala"
	self->priv->type_modebutton = _tmp38_;
#line 242 "../src/MainWindow.vala"
	_tmp39_ = self->priv->type_modebutton;
#line 242 "../src/MainWindow.vala"
	_tmp40_ = utils_display_type_to_string (UTILS_DISPLAY_TYPE_INTERNAL);
#line 242 "../src/MainWindow.vala"
	_tmp41_ = _tmp40_;
#line 242 "../src/MainWindow.vala"
	granite_widgets_mode_button_append_text (_tmp39_, _tmp41_);
#line 242 "../src/MainWindow.vala"
	_g_free0 (_tmp41_);
#line 243 "../src/MainWindow.vala"
	_tmp42_ = self->priv->type_modebutton;
#line 243 "../src/MainWindow.vala"
	_tmp43_ = utils_display_type_to_string (UTILS_DISPLAY_TYPE_EXTERNAL);
#line 243 "../src/MainWindow.vala"
	_tmp44_ = _tmp43_;
#line 243 "../src/MainWindow.vala"
	granite_widgets_mode_button_append_text (_tmp42_, _tmp44_);
#line 243 "../src/MainWindow.vala"
	_g_free0 (_tmp44_);
#line 245 "../src/MainWindow.vala"
	_tmp45_ = (GtkLabel*) gtk_label_new (NULL);
#line 245 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp45_);
#line 245 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aspect_result_label);
#line 245 "../src/MainWindow.vala"
	self->priv->aspect_result_label = _tmp45_;
#line 246 "../src/MainWindow.vala"
	_tmp46_ = self->priv->aspect_result_label;
#line 246 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_START);
#line 247 "../src/MainWindow.vala"
	_tmp47_ = self->priv->aspect_result_label;
#line 247 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp47_, TRUE);
#line 249 "../src/MainWindow.vala"
	_tmp48_ = (GtkLabel*) gtk_label_new (NULL);
#line 249 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp48_);
#line 249 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->dpi_result_label);
#line 249 "../src/MainWindow.vala"
	self->priv->dpi_result_label = _tmp48_;
#line 250 "../src/MainWindow.vala"
	_tmp49_ = self->priv->dpi_result_label;
#line 250 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp49_, GTK_ALIGN_START);
#line 251 "../src/MainWindow.vala"
	_tmp50_ = self->priv->dpi_result_label;
#line 251 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp50_, TRUE);
#line 253 "../src/MainWindow.vala"
	_tmp51_ = (GtkLabel*) gtk_label_new (NULL);
#line 253 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp51_);
#line 253 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->logical_resolution_label);
#line 253 "../src/MainWindow.vala"
	self->priv->logical_resolution_label = _tmp51_;
#line 254 "../src/MainWindow.vala"
	_tmp52_ = self->priv->logical_resolution_label;
#line 254 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp52_, "expand", TRUE, NULL);
#line 255 "../src/MainWindow.vala"
	_tmp53_ = self->priv->logical_resolution_label;
#line 255 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
#line 256 "../src/MainWindow.vala"
	_tmp54_ = self->priv->logical_resolution_label;
#line 256 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp54_, TRUE);
#line 258 "../src/MainWindow.vala"
	_tmp55_ = main_window_range_icon (MAIN_WINDOW_RANGE_INVALID);
#line 258 "../src/MainWindow.vala"
	_tmp56_ = _tmp55_;
#line 258 "../src/MainWindow.vala"
	_tmp57_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp56_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 258 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp57_);
#line 258 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_icon);
#line 258 "../src/MainWindow.vala"
	self->priv->range_icon = _tmp57_;
#line 258 "../src/MainWindow.vala"
	_g_free0 (_tmp56_);
#line 262 "../src/MainWindow.vala"
	_tmp58_ = self->priv->range_icon;
#line 262 "../src/MainWindow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp58_, 12);
#line 263 "../src/MainWindow.vala"
	_tmp59_ = self->priv->range_icon;
#line 263 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp59_, GTK_ALIGN_START);
#line 265 "../src/MainWindow.vala"
	_tmp60_ = (GtkLabel*) gtk_label_new (NULL);
#line 265 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp60_);
#line 265 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_title_label);
#line 265 "../src/MainWindow.vala"
	self->priv->range_title_label = _tmp60_;
#line 266 "../src/MainWindow.vala"
	_tmp61_ = self->priv->range_title_label;
#line 266 "../src/MainWindow.vala"
	g_object_set (_tmp61_, "wrap", TRUE, NULL);
#line 267 "../src/MainWindow.vala"
	_tmp62_ = self->priv->range_title_label;
#line 267 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_START);
#line 268 "../src/MainWindow.vala"
	_tmp63_ = self->priv->range_title_label;
#line 268 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp63_, TRUE);
#line 269 "../src/MainWindow.vala"
	_tmp64_ = self->priv->range_title_label;
#line 269 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp64_, (gfloat) 0);
#line 270 "../src/MainWindow.vala"
	_tmp65_ = self->priv->range_title_label;
#line 270 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp65_, GTK_ALIGN_END);
#line 271 "../src/MainWindow.vala"
	_tmp66_ = self->priv->range_title_label;
#line 271 "../src/MainWindow.vala"
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
#line 271 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp67_, "h2");
#line 272 "../src/MainWindow.vala"
	_tmp68_ = self->priv->range_title_label;
#line 272 "../src/MainWindow.vala"
	_tmp69_ = main_window_range_title (MAIN_WINDOW_RANGE_INVALID);
#line 272 "../src/MainWindow.vala"
	_tmp70_ = _tmp69_;
#line 272 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp68_, _tmp70_);
#line 272 "../src/MainWindow.vala"
	_g_free0 (_tmp70_);
#line 274 "../src/MainWindow.vala"
	_tmp71_ = (GtkLabel*) gtk_label_new (NULL);
#line 274 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp71_);
#line 274 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_description_label);
#line 274 "../src/MainWindow.vala"
	self->priv->range_description_label = _tmp71_;
#line 275 "../src/MainWindow.vala"
	_tmp72_ = self->priv->range_description_label;
#line 275 "../src/MainWindow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp72_, 12);
#line 276 "../src/MainWindow.vala"
	_tmp73_ = self->priv->range_description_label;
#line 276 "../src/MainWindow.vala"
	gtk_label_set_max_width_chars (_tmp73_, 50);
#line 277 "../src/MainWindow.vala"
	_tmp74_ = self->priv->range_description_label;
#line 277 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp74_, TRUE);
#line 278 "../src/MainWindow.vala"
	_tmp75_ = self->priv->range_description_label;
#line 278 "../src/MainWindow.vala"
	g_object_set (_tmp75_, "wrap", TRUE, NULL);
#line 279 "../src/MainWindow.vala"
	_tmp76_ = self->priv->range_description_label;
#line 279 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp76_, (gfloat) 0);
#line 280 "../src/MainWindow.vala"
	_tmp77_ = self->priv->range_description_label;
#line 280 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp77_, GTK_ALIGN_START);
#line 281 "../src/MainWindow.vala"
	_tmp78_ = self->priv->range_description_label;
#line 281 "../src/MainWindow.vala"
	_tmp79_ = main_window_range_description (MAIN_WINDOW_RANGE_INVALID);
#line 281 "../src/MainWindow.vala"
	_tmp80_ = _tmp79_;
#line 281 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp78_, _tmp80_);
#line 281 "../src/MainWindow.vala"
	_g_free0 (_tmp80_);
#line 283 "../src/MainWindow.vala"
	_tmp81_ = self->priv->diag_entry;
#line 283 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp81_, "changed", (GCallback) __main_window___lambda7__gtk_editable_changed, self, 0);
#line 291 "../src/MainWindow.vala"
	_tmp82_ = self->priv->width_entry;
#line 291 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp82_, "changed", (GCallback) __main_window___lambda8__gtk_editable_changed, self, 0);
#line 313 "../src/MainWindow.vala"
	_tmp83_ = self->priv->height_entry;
#line 313 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp83_, "changed", (GCallback) __main_window___lambda9__gtk_editable_changed, self, 0);
#line 335 "../src/MainWindow.vala"
	_tmp84_ = self->priv->type_modebutton;
#line 335 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp84_, "mode-changed", (GCallback) __main_window___lambda10__granite_widgets_mode_button_mode_changed, self, 0);
#line 353 "../src/MainWindow.vala"
	_tmp85_ = (GtkGrid*) gtk_grid_new ();
#line 353 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp85_);
#line 353 "../src/MainWindow.vala"
	data_grid = _tmp85_;
#line 354 "../src/MainWindow.vala"
	_tmp86_ = data_grid;
#line 354 "../src/MainWindow.vala"
	gtk_grid_set_column_spacing (_tmp86_, 6);
#line 355 "../src/MainWindow.vala"
	_tmp87_ = data_grid;
#line 355 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp87_, "margin", 24, NULL);
#line 356 "../src/MainWindow.vala"
	_tmp88_ = data_grid;
#line 356 "../src/MainWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp88_, 0);
#line 357 "../src/MainWindow.vala"
	_tmp89_ = data_grid;
#line 357 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp89_, 6);
#line 358 "../src/MainWindow.vala"
	_tmp90_ = data_grid;
#line 358 "../src/MainWindow.vala"
	_tmp91_ = gtk_widget_get_style_context ((GtkWidget*) _tmp90_);
#line 358 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp91_, "data-grid");
#line 360 "../src/MainWindow.vala"
	_tmp92_ = data_grid;
#line 360 "../src/MainWindow.vala"
	_tmp93_ = self->priv->diagram;
#line 360 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 0, 0, 5, 1);
#line 361 "../src/MainWindow.vala"
	_tmp94_ = data_grid;
#line 361 "../src/MainWindow.vala"
	_tmp95_ = diag_label;
#line 361 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 0, 1, 1, 1);
#line 362 "../src/MainWindow.vala"
	_tmp96_ = data_grid;
#line 362 "../src/MainWindow.vala"
	_tmp97_ = self->priv->diag_entry;
#line 362 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 1, 1, 1, 1);
#line 363 "../src/MainWindow.vala"
	_tmp98_ = data_grid;
#line 363 "../src/MainWindow.vala"
	_tmp99_ = inches_label;
#line 363 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp98_, (GtkWidget*) _tmp99_, 2, 1, 2, 1);
#line 364 "../src/MainWindow.vala"
	_tmp100_ = data_grid;
#line 364 "../src/MainWindow.vala"
	_tmp101_ = res_label;
#line 364 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp100_, (GtkWidget*) _tmp101_, 0, 2, 1, 1);
#line 365 "../src/MainWindow.vala"
	_tmp102_ = data_grid;
#line 365 "../src/MainWindow.vala"
	_tmp103_ = self->priv->width_entry;
#line 365 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp102_, (GtkWidget*) _tmp103_, 1, 2, 1, 1);
#line 366 "../src/MainWindow.vala"
	_tmp104_ = data_grid;
#line 366 "../src/MainWindow.vala"
	_tmp105_ = x_label;
#line 366 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp104_, (GtkWidget*) _tmp105_, 2, 2, 1, 1);
#line 367 "../src/MainWindow.vala"
	_tmp106_ = data_grid;
#line 367 "../src/MainWindow.vala"
	_tmp107_ = self->priv->height_entry;
#line 367 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp106_, (GtkWidget*) _tmp107_, 3, 2, 1, 1);
#line 368 "../src/MainWindow.vala"
	_tmp108_ = data_grid;
#line 368 "../src/MainWindow.vala"
	_tmp109_ = px_label;
#line 368 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp108_, (GtkWidget*) _tmp109_, 4, 2, 1, 1);
#line 369 "../src/MainWindow.vala"
	_tmp110_ = data_grid;
#line 369 "../src/MainWindow.vala"
	_tmp111_ = type_label;
#line 369 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp110_, (GtkWidget*) _tmp111_, 0, 3, 1, 1);
#line 370 "../src/MainWindow.vala"
	_tmp112_ = data_grid;
#line 370 "../src/MainWindow.vala"
	_tmp113_ = self->priv->type_modebutton;
#line 370 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp112_, (GtkWidget*) _tmp113_, 1, 3, 4, 1);
#line 372 "../src/MainWindow.vala"
	_tmp114_ = (GtkGrid*) gtk_grid_new ();
#line 372 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp114_);
#line 372 "../src/MainWindow.vala"
	assessment_grid = _tmp114_;
#line 373 "../src/MainWindow.vala"
	_tmp115_ = assessment_grid;
#line 373 "../src/MainWindow.vala"
	gtk_grid_set_column_spacing (_tmp115_, 12);
#line 374 "../src/MainWindow.vala"
	_tmp116_ = assessment_grid;
#line 374 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp116_, GTK_ALIGN_START);
#line 375 "../src/MainWindow.vala"
	_tmp117_ = assessment_grid;
#line 375 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp117_, "margin", 12, NULL);
#line 376 "../src/MainWindow.vala"
	_tmp118_ = assessment_grid;
#line 376 "../src/MainWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp118_, 48);
#line 377 "../src/MainWindow.vala"
	_tmp119_ = assessment_grid;
#line 377 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp119_, 6);
#line 378 "../src/MainWindow.vala"
	_tmp120_ = assessment_grid;
#line 378 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp120_, GTK_ALIGN_START);
#line 379 "../src/MainWindow.vala"
	_tmp121_ = assessment_grid;
#line 379 "../src/MainWindow.vala"
	_tmp122_ = gtk_widget_get_style_context ((GtkWidget*) _tmp121_);
#line 379 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp122_, "assessment-grid");
#line 381 "../src/MainWindow.vala"
	_tmp123_ = assessment_grid;
#line 381 "../src/MainWindow.vala"
	_tmp124_ = self->priv->range_icon;
#line 381 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp123_, (GtkWidget*) _tmp124_, 0, 0, 1, 2);
#line 382 "../src/MainWindow.vala"
	_tmp125_ = assessment_grid;
#line 382 "../src/MainWindow.vala"
	_tmp126_ = self->priv->range_title_label;
#line 382 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, 1, 0, 3, 1);
#line 383 "../src/MainWindow.vala"
	_tmp127_ = assessment_grid;
#line 383 "../src/MainWindow.vala"
	_tmp128_ = self->priv->range_description_label;
#line 383 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp127_, (GtkWidget*) _tmp128_, 1, 1, 3, 1);
#line 384 "../src/MainWindow.vala"
	_tmp129_ = assessment_grid;
#line 384 "../src/MainWindow.vala"
	_tmp130_ = self->priv->aspect_result_label;
#line 384 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, 1, 2, 1, 1);
#line 385 "../src/MainWindow.vala"
	_tmp131_ = assessment_grid;
#line 385 "../src/MainWindow.vala"
	_tmp132_ = self->priv->dpi_result_label;
#line 385 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp131_, (GtkWidget*) _tmp132_, 2, 2, 1, 1);
#line 386 "../src/MainWindow.vala"
	_tmp133_ = assessment_grid;
#line 386 "../src/MainWindow.vala"
	_tmp134_ = self->priv->logical_resolution_label;
#line 386 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp133_, (GtkWidget*) _tmp134_, 3, 2, 1, 1);
#line 388 "../src/MainWindow.vala"
	_tmp135_ = (GtkGrid*) gtk_grid_new ();
#line 388 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp135_);
#line 388 "../src/MainWindow.vala"
	main_layout = _tmp135_;
#line 389 "../src/MainWindow.vala"
	_tmp136_ = main_layout;
#line 389 "../src/MainWindow.vala"
	gtk_grid_set_column_spacing (_tmp136_, 6);
#line 390 "../src/MainWindow.vala"
	_tmp137_ = main_layout;
#line 390 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp137_, "height-request", 258, NULL);
#line 391 "../src/MainWindow.vala"
	_tmp138_ = main_layout;
#line 391 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp138_, 6);
#line 392 "../src/MainWindow.vala"
	_tmp139_ = main_layout;
#line 392 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp139_, "width-request", 710, NULL);
#line 393 "../src/MainWindow.vala"
	_tmp140_ = main_layout;
#line 393 "../src/MainWindow.vala"
	_tmp141_ = data_grid;
#line 393 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp140_, (GtkWidget*) _tmp141_, 0, 0, 1, 1);
#line 394 "../src/MainWindow.vala"
	_tmp142_ = main_layout;
#line 394 "../src/MainWindow.vala"
	_tmp143_ = assessment_grid;
#line 394 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp142_, (GtkWidget*) _tmp143_, 1, 0, 1, 1);
#line 396 "../src/MainWindow.vala"
	_tmp144_ = self->priv->diag_entry;
#line 396 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp144_);
#line 398 "../src/MainWindow.vala"
	_tmp145_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 398 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp145_, "dippi");
#line 399 "../src/MainWindow.vala"
	_tmp146_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 399 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp146_, "rounded");
#line 400 "../src/MainWindow.vala"
	_tmp147_ = header;
#line 400 "../src/MainWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp147_);
#line 401 "../src/MainWindow.vala"
	_tmp148_ = main_layout;
#line 401 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp148_);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (main_layout);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (assessment_grid);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (data_grid);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (type_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (inches_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (px_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (x_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (res_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (diag_label);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (header_context);
#line 181 "../src/MainWindow.vala"
	_g_object_unref0 (header);
#line 181 "../src/MainWindow.vala"
	return obj;
#line 2284 "MainWindow.c"
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
#line 22 "../src/MainWindow.vala"
	main_window_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
#line 2299 "MainWindow.c"
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
	gchar* _tmp0_;
#line 22 "../src/MainWindow.vala"
	self->priv = main_window_get_instance_private (self);
#line 145 "../src/MainWindow.vala"
	self->priv->aspect_width = MAIN_WINDOW_DEFAULT_ASPECT_WIDTH;
#line 146 "../src/MainWindow.vala"
	self->priv->aspect_height = MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT;
#line 148 "../src/MainWindow.vala"
	self->priv->inches = 0.0;
#line 149 "../src/MainWindow.vala"
	self->priv->width = 0;
#line 150 "../src/MainWindow.vala"
	self->priv->height = 0;
#line 151 "../src/MainWindow.vala"
	self->priv->is_default_display_type = TRUE;
#line 152 "../src/MainWindow.vala"
	self->priv->is_default_width = TRUE;
#line 153 "../src/MainWindow.vala"
	self->priv->is_default_height = TRUE;
#line 154 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("");
#line 154 "../src/MainWindow.vala"
	self->priv->direction = _tmp0_;
#line 2329 "MainWindow.c"
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
#line 22 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 154 "../src/MainWindow.vala"
	_g_free0 (self->priv->direction);
#line 156 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->diagram);
#line 157 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->diag_entry);
#line 158 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->width_entry);
#line 159 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->height_entry);
#line 160 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->dpi_result_label);
#line 161 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->logical_resolution_label);
#line 162 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aspect_result_label);
#line 163 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->type_modebutton);
#line 164 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_title_label);
#line 165 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_description_label);
#line 166 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->range_icon);
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
#line 2364 "MainWindow.c"
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
		GType main_window_type_id;
		main_window_type_id = g_type_register_static (gtk_window_get_type (), "MainWindow", &g_define_type_info, 0);
		MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}

