/* Utils.c generated by valac 0.43.6, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright (c) 2018 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

typedef enum  {
	UTILS_DISPLAY_TYPE_INTERNAL,
	UTILS_DISPLAY_TYPE_EXTERNAL
} UtilsDisplayType;

#define UTILS_TYPE_DISPLAY_TYPE (utils_display_type_get_type ())

GType utils_display_type_get_type (void) G_GNUC_CONST;
gchar* utils_display_type_to_string (UtilsDisplayType self);
gchar* utils_display_type_icon_suffix (UtilsDisplayType self);
gint utils_dpi (gdouble inches,
                gint width,
                gint height);
gint utils_greatest_common_divisor (gint a,
                                    gint b);

gchar*
utils_display_type_to_string (UtilsDisplayType self)
{
	gchar* result = NULL;
#line 28 "../src/Utils.vala"
	switch (self) {
#line 28 "../src/Utils.vala"
		case UTILS_DISPLAY_TYPE_INTERNAL:
#line 58 "Utils.c"
		{
			gchar* _tmp0_;
#line 30 "../src/Utils.vala"
			_tmp0_ = g_strdup (_ ("Laptop"));
#line 30 "../src/Utils.vala"
			result = _tmp0_;
#line 30 "../src/Utils.vala"
			return result;
#line 67 "Utils.c"
		}
#line 28 "../src/Utils.vala"
		case UTILS_DISPLAY_TYPE_EXTERNAL:
#line 71 "Utils.c"
		{
			gchar* _tmp1_;
#line 33 "../src/Utils.vala"
			_tmp1_ = g_strdup (_ ("Desktop"));
#line 33 "../src/Utils.vala"
			result = _tmp1_;
#line 33 "../src/Utils.vala"
			return result;
#line 80 "Utils.c"
		}
		default:
		{
#line 36 "../src/Utils.vala"
			g_assert_not_reached ();
#line 86 "Utils.c"
		}
	}
}

gchar*
utils_display_type_icon_suffix (UtilsDisplayType self)
{
	gchar* result = NULL;
#line 41 "../src/Utils.vala"
	switch (self) {
#line 41 "../src/Utils.vala"
		case UTILS_DISPLAY_TYPE_INTERNAL:
#line 99 "Utils.c"
		{
			gchar* _tmp0_;
#line 43 "../src/Utils.vala"
			_tmp0_ = g_strdup ("-notebook");
#line 43 "../src/Utils.vala"
			result = _tmp0_;
#line 43 "../src/Utils.vala"
			return result;
#line 108 "Utils.c"
		}
#line 41 "../src/Utils.vala"
		case UTILS_DISPLAY_TYPE_EXTERNAL:
#line 112 "Utils.c"
		{
			gchar* _tmp1_;
#line 46 "../src/Utils.vala"
			_tmp1_ = g_strdup ("");
#line 46 "../src/Utils.vala"
			result = _tmp1_;
#line 46 "../src/Utils.vala"
			return result;
#line 121 "Utils.c"
		}
		default:
		{
#line 49 "../src/Utils.vala"
			g_assert_not_reached ();
#line 127 "Utils.c"
		}
	}
}

GType
utils_display_type_get_type (void)
{
	static volatile gsize utils_display_type_type_id__volatile = 0;
	if (g_once_init_enter (&utils_display_type_type_id__volatile)) {
		static const GEnumValue values[] = {{UTILS_DISPLAY_TYPE_INTERNAL, "UTILS_DISPLAY_TYPE_INTERNAL", "internal"}, {UTILS_DISPLAY_TYPE_EXTERNAL, "UTILS_DISPLAY_TYPE_EXTERNAL", "external"}, {0, NULL, NULL}};
		GType utils_display_type_type_id;
		utils_display_type_type_id = g_enum_register_static ("UtilsDisplayType", values);
		g_once_init_leave (&utils_display_type_type_id__volatile, utils_display_type_type_id);
	}
	return utils_display_type_type_id__volatile;
}

gint
utils_dpi (gdouble inches,
           gint width,
           gint height)
{
	gint result = 0;
	gdouble unrounded_dpi = 0.0;
	gint rounded_dpi = 0;
#line 55 "../src/Utils.vala"
	unrounded_dpi = sqrt (pow ((gdouble) width, (gdouble) 2) + pow ((gdouble) height, (gdouble) 2)) / inches;
#line 59 "../src/Utils.vala"
	rounded_dpi = (gint) unrounded_dpi;
#line 61 "../src/Utils.vala"
	result = rounded_dpi;
#line 61 "../src/Utils.vala"
	return result;
#line 161 "Utils.c"
}

gint
utils_greatest_common_divisor (gint a,
                               gint b)
{
	gint result = 0;
#line 65 "../src/Utils.vala"
	if (a == 0) {
#line 66 "../src/Utils.vala"
		result = b;
#line 66 "../src/Utils.vala"
		return result;
#line 175 "Utils.c"
	}
#line 69 "../src/Utils.vala"
	if (b == 0) {
#line 70 "../src/Utils.vala"
		result = a;
#line 70 "../src/Utils.vala"
		return result;
#line 183 "Utils.c"
	}
#line 73 "../src/Utils.vala"
	if (a > b) {
#line 74 "../src/Utils.vala"
		result = utils_greatest_common_divisor (a % b, b);
#line 74 "../src/Utils.vala"
		return result;
#line 191 "Utils.c"
	} else {
#line 76 "../src/Utils.vala"
		result = utils_greatest_common_divisor (a, b % a);
#line 76 "../src/Utils.vala"
		return result;
#line 197 "Utils.c"
	}
}

